import java.util.List;

public interface Graph {
	
	/** Return the number of nodes in the graph */
	public int numNodes();
	
	/** Return a list of edges in the graph */
	public List<Pair> getEdges();
	
	/** Check whether an edge exists */
	public boolean hasEdge(int u, int v);

	/** Return a list of neighbors of n.
	 * Precondition: 0 <= n < number of nodes */
	public List<Integer> getNeighbors(int n);	

	/** Print the graph.
	 * Precondition: the graph has < 100 nodes */
	public void printGraph();
}
